#lang racket/base
(require "global.rkt")

(provide mem-array
         get-mem
         set-mem!)

;; mem-array : (vector value), initialized to 0
(define mem-array (make-vector MAX-ADD 0))

;; get-mem : number[address] -> value
(define (get-mem addr)
  (if (address? addr)
      (vector-ref mem-array addr)
      (error 'get-mem "invalid address: ~s" addr)))

;; set-mem! : number[address] number[value] -> void
(define (set-mem! addr val)
  (if (and (address? addr) (value? val))
      (vector-set! mem-array addr val)
      (error 'set-mem! "invalid address/value: ~s ~s" addr val)))


