#lang racket/base
(require "global.rkt"
         "reg.rkt")

(provide arithmetic
         checked-for-0
         make-ld-st/x)

;; arithmetic : (value value -> value) -> instruction
(define (arithmetic op)
  (lambda (sign digits) 
    (set-reg! (vector-ref digits 2)
      (op (get-reg (vector-ref digits 3)) (get-reg (vector-ref digits 4))))))

;; checked-for-0 : (value value -> value) -> (value value -> value)
(define (checked-for-0 op)
  (lambda (v1 v2)
    (if (= v2 0)
	(error 'division "division by 0")
	(op v1 v2))))

;; make-ld-st/x : (digit address -> void) -> instruction
(define (make-ld-st/x f)
  (lambda (sign digits)
    (let ((r (vector-ref digits 2)))
      (if (register? r)
	  (f r
	     (+ (get-reg (vector-ref digits 3))
		(if (> (vector-ref digits 5) 0)
		    0
		    (get-reg (vector-ref digits 4)))))
	  (error "bad register in load/store ~s" r)))))
